"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DrizzlePostgresModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const postgres_js_definition_1 = require("./postgres-js.definition");
const postgres_js_service_1 = require("./postgres-js.service");
let DrizzlePostgresModule = exports.DrizzlePostgresModule = class DrizzlePostgresModule extends postgres_js_definition_1.ConfigurableModuleClass {
    static register(options) {
        const { providers = [], exports = [], ...props } = super.register(options);
        return {
            ...props,
            providers: [
                ...providers,
                postgres_js_service_1.DrizzlePostgresService,
                {
                    provide: options?.tag || 'default',
                    useFactory: async (drizzleService) => {
                        return await drizzleService.getDrizzle(options);
                    },
                    inject: [postgres_js_service_1.DrizzlePostgresService],
                },
            ],
            exports: [...exports, options?.tag || 'default'],
        };
    }
    static registerAsync(options) {
        const { providers = [], exports = [], ...props } = super.registerAsync(options);
        return {
            ...props,
            providers: [
                ...providers,
                postgres_js_service_1.DrizzlePostgresService,
                {
                    provide: options?.tag || 'default',
                    useFactory: async (drizzleService, config) => {
                        return await drizzleService.getDrizzle(config);
                    },
                    inject: [postgres_js_service_1.DrizzlePostgresService, postgres_js_definition_1.MODULE_OPTIONS_TOKEN],
                },
            ],
            exports: [...exports, options?.tag || 'default'],
        };
    }
};
exports.DrizzlePostgresModule = DrizzlePostgresModule = tslib_1.__decorate([
    (0, common_1.Global)()
], DrizzlePostgresModule);
//# sourceMappingURL=postgres-js.module.js.map